SETTINGS_MQTT_TOPIC = "/iq/bridge/network_manager/settings"
# STORAGE_MQTT_TOPIC = "/iq/bridge/network_manager/storage"  # local topic
RESULT_MQTT_TOPIC = "/iq/bridge/network_manager/log"
# STAT_MQTT_TOPIC = "/iq/bridge/network_manager/stat"


CONFIG_FILE_NAME = 'config.py'
WB_HARDWARE_CONF_FILE_PATH = "/etc/wb-hardware.conf"


DELAY_NO_INTERNET = 60
DELAY_WITH_INTERNET = 60  # TODO 300
NO_INTERNET_MAX_COUNT = 60

# DEFAULT_DELAY = 15
DELAY_DEFAULT = 15
DELAY_GSM = 10

# GSM_COMMAND_DELAY = 1
DELAY_COMMAND = 1

DELAY_COMMAND_RESULT = 3


LINUX_INTERFACES_FILE_PATH = "/etc/network/interfaces"
LINUX_INTERFACES_BACKUP_FILE_PATH = "/etc/network/interfaces.bak"

# MODEM_DEV_DEFAULT = '/dev/ttyGSM'

MODEM_DEV_AT_COMMAND = '/dev/ttyGSM1'
MODEM_DEV_DEFAULT_4G = '/dev/ttyGSM'

# MODEM_DEV_DEFAULT_3G = '/dev/ttyACM0'
# MODEM_DEV_TEMPLATE_3G = '/dev/ttyACM{0}'


PPP_PROVIDER_MTS = "mts"
PPP_PROVIDER_BEELINE = "beeline"
PPP_PROVIDER_MEGAFON = "megafon"
PPP_PROVIDER_TELE2 = "tele2"
# PPP_PROVIDER_LIST = [PPP_PROVIDER_MTS, PPP_PROVIDER_BEELINE, PPP_PROVIDER_MEGAFON, PPP_PROVIDER_TELE2]
PPP_PROVIDER_LIST = [PPP_PROVIDER_MTS, PPP_PROVIDER_BEELINE, PPP_PROVIDER_MEGAFON]

PPP_PROVIDER_DEFAULT = PPP_PROVIDER_MTS
PPP_PROVIDER_DIR_FILE_PATH = '/etc/ppp/peers'
PPP_PROVIDER_FILE_PATH_TEMPLATE = '{0}/{{0}}'.format(PPP_PROVIDER_DIR_FILE_PATH)


MODEM_TYPE_DEFAULT = 'DEFAULT'
MODEM_TYPE_3G = '3G'
MODEM_TYPE_4G = '4G'

LO_INTERFACE_NAME = "lo"
ETH0_INTERFACE_NAME = "eth0"
ETH1_INTERFACE_NAME = "eth1"
WLAN_INTERFACE_NAME = "wlan0"
FREE_WLAN_INTERFACE_NAME = "wlan0_free"
PPP_INTERFACE_NAME = "ppp0"
USB0_INTERFACE_NAME = "usb0"


LO_INTERFACE_TEMPLATE = """
auto {0}
iface {0} inet loopback
"""

ETH_INTERFACE_TEMPLATE = """
auto {0}
allow-hotplug {0}

iface {0} inet dhcp
    pre-up wb-set-mac
    hostname IQnergy
"""

# PPP_INTERFACE_TEMPLATE = """
# auto {{0}}
#
# iface {{0}} inet ppp
#     pre-up wb-gsm restart_if_broken
#     pre-up sleep {0}
#     provider {{{{0}}}}
# """.format(DELAY_GSM)

PPP_INTERFACE_TEMPLATE = """
auto {0}

iface {0} inet ppp
    provider {{0}}
"""

WLAN_INTERFACE_TEMPLATE = """
auto {0}

iface {0} inet dhcp
    wpa-ssid "{{0}}"
    wpa-psk "{{1}}"
"""

FREE_WLAN_INTERFACE_TEMPLATE = """
auto {0}

iface {0} inet dhcp
    wireless-essid "{{0}}"
"""

# USB0_INTERFACE_TEMPLATE = """
# auto {0}
# allow-hotplug {0}
#
# iface {0} inet dhcp
#    hostname IQnergy
#    pre-up wb-gsm restart_if_broken
# """

INTERFACE_SETTINGS_TEMPLATE = {
    LO_INTERFACE_NAME: (LO_INTERFACE_TEMPLATE.format(LO_INTERFACE_NAME), 0),
    ETH0_INTERFACE_NAME: (ETH_INTERFACE_TEMPLATE.format(ETH0_INTERFACE_NAME), 1),
    ETH1_INTERFACE_NAME: (ETH_INTERFACE_TEMPLATE.format(ETH1_INTERFACE_NAME), 2),
    PPP_INTERFACE_NAME: (PPP_INTERFACE_TEMPLATE.format(PPP_INTERFACE_NAME), 3),
    WLAN_INTERFACE_NAME: (WLAN_INTERFACE_TEMPLATE.format(WLAN_INTERFACE_NAME), 4)
    # USB0_INTERFACE_NAME: (USB0_INTERFACE_TEMPLATE.format(USB0_INTERFACE_NAME), 5)
}

FREE_WLAN_INTERFACE_DATA = FREE_WLAN_INTERFACE_TEMPLATE.format(WLAN_INTERFACE_NAME)
# USB0_INTERFACE_DATA = USB0_INTERFACE_TEMPLATE.format(USB0_INTERFACE_NAME)

BASE_INTERFACES = [LO_INTERFACE_NAME, ETH0_INTERFACE_NAME, ETH1_INTERFACE_NAME, PPP_INTERFACE_NAME]

DEFAULT_INTERFACE_PRIORITY = 0

# DEFAULT_SETTINGS = {
DEFAULT_INTERFACE_SETTINGS = {
    PPP_INTERFACE_NAME: {
        "priority": -2
    },
    WLAN_INTERFACE_NAME: {
        # "is_active": False,
        "priority": -1,
        "ssid": "IQnetwork",
        "key": "Smart_Password!"
    },
    ETH1_INTERFACE_NAME: {
        "is_active": False
    }
}
